gstreamermm: Gst::Segment Class Reference

gstreamermm 0.10.10

- Main Page
- Modules
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Attributes | Related Functions

# Gst::Segment Class Reference

A class that describes the configured region of interest in a media file. More...

List of all members.

## Public Member Functions
| Segment ()
| Segment (GstSegment* gobject, bool make_a_copy=true)
| Segment (const Segment& other)
Segment& | operator= (const Segment& other)
| ~Segment ()
void | swap (Segment& other)
GstSegment* | gobj ()
| Provides access to the underlying C instance.
const GstSegment* | gobj () const
| Provides access to the underlying C instance.
GstSegment* | gobj_copy () const
| Provides access to the underlying C instance. The caller is responsible for freeing it. Use when directly setting fields in structs.
bool | clip (Format format, gint64 start, gint64 stop, gint64& clip_start, gint64& clip_stop) const
| Clip the given start and stop values to the segment boundaries given in segment.
void | init (Format format)
| The start/last_stop positions are set to 0 and the stop/duration fields are set to -1 (unknown).
void | set_duration (Format format, gint64 duration)
| Set the duration of the segment to duration.
void | set_last_stop (Format format, gint64 position)
| Set the last observed stop position in the segment to position.
void | set_newsegment (bool update, double rate, Format format, gint64 start, gint64 stop, gint64 time)
| Update the segment structure with the field values of a new segment event and with a default applied_rate of 1.0.
void | set_newsegment (bool update, double rate, double applied_rate, Format format, gint64 start, gint64 stop, gint64 time)
| Update the segment structure with the field values of a new segment event.
void | set_seek (double rate, Format format, SeekFlags flags, SeekType start_type, gint64 start, SeekType stop_type, gint64 stop, bool& update)
| Update the segment structure with the field values of a seek event (see Gst::Event::new_seek()).
gint64 | to_running_time (Format format, gint64 position) const
| Translate position to the total running time using the currently configured and previously accumulated segments.
gint64 | to_stream_time (Format format, gint64 position) const
| Translate position to stream time using the currently configured segment.
gint64 | to_position (Format format, gint64 running_time) const
| Convert running_time into a position in the segment so that to_running_time() with that position returns running_time.
bool | set_running_time (Format format, gint64 running_time)
| Adjust the start/stop and accum values of segment such that the next valid buffer will be one with running_time.
## Protected Attributes
GstSegment* | gobject_
## Related Functions
(Note that these are not member functions.)
void | swap (Segment& lhs, Segment& rhs)
Gst::Segment | wrap (GstSegment* object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Detailed Description

A class that describes the configured region of interest in a media file.

This helper structure holds the relevant values for tracking the region of interest in a media file, called a segment.

The structure can be used for two purposes:

- performing seeks (handling seek events)
- tracking playback regions (handling newsegment events)

The segment is usually configured by the application with a seek event which is propagated upstream and eventually handled by an element that performs the seek.

The configured segment is then propagated back downstream with a newsegment event. This information is then used to clip media to the segment boundaries.

A segment structure is initialized with init(), which takes a Format that will be used as the format of the segment values. The segment will be configured with a start value of 0 and a stop/duration of -1, which is undefined. The default rate and applied_rate is 1.0.

If the segment is used for managing seeks, the segment duration should be set with set_duration(). The public duration field contains the duration of the segment. When using the segment for seeking, the start and time members should normally be left to their default 0 value. The stop position is left to -1 unless explicitly configured to a different value after a seek event.

The current position in the segment should be set with the set_last_stop(). The public last_stop field contains the last set stop position in the segment.

For elements that perform seeks, the current segment should be updated with the set_seek() and the values from the seek event. This method will update all the segment fields. The last_stop field will contain the new playback position. If the cur_type was different from Gst::SEEK_TYPE_NONE, playback continues from the last_stop position, possibly with updated flags or rate.

For elements that want to use Gst::Segment to track the playback region, use set_newsegment() to update the segment fields with the information from the newsegment event. The clip() method can be used to check and clip the media data to the segment boundaries.

For elements that want to synchronize to the pipeline clock, to_running_time() can be used to convert a timestamp to a value that can be used to synchronize to the clock. This function takes into account all accumulated segments as well as any rate or applied_rate conversions.

For elements that need to perform operations on media data in stream_time, to_stream_time() can be used to convert a timestamp and the segment info to stream time (which is always between 0 and the duration of the stream).

Last reviewed on 2007-05-17 (0.10.13)

## Constructor & Destructor Documentation

Gst::Segment::Segment | ( |  | ) |

Gst::Segment::Segment | ( | GstSegment * | gobject,
|  | bool | make_a_copy = `true`
| ) |  | `[explicit]`

Gst::Segment::Segment | ( | const Segment& | other | ) |

Gst::Segment::~Segment | ( |  | ) |

## Member Function Documentation

bool Gst::Segment::clip | ( | Format | format,
|  | gint64 | start,
|  | gint64 | stop,
|  | gint64 & | clip_start,
|  | gint64 & | clip_stop
| ) |  | const

Clip the given start and stop values to the segment boundaries given in segment.

start and stop are compared and clipped to segment start and stop values.

If the function returns `false`, start and stop are known to fall outside of segment and clip_start and clip_stop are not updated.

When the function returns `true`, clip_start and clip_stop will be updated. If clip_start or clip_stop are different from start or stop respectively, the region fell partially in the segment.

Note that when stop is -1, clip_stop will be set to the end of the segment. Depending on the use case, this may or may not be what you want.

Parameters:

  format | The format of the segment.
  start | The start position in the segment.
  stop | The stop position in the segment.
  clip_start | The clipped start position in the segment.
  clip_stop | The clipped stop position in the segment.

Returns:
  `true` if the given start and stop times fall partially or completely in segment, `false` if the values are completely outside of the segment.

const GstSegment* Gst::Segment::gobj | ( |  | ) | const`[inline]`

Provides access to the underlying C instance.

GstSegment* Gst::Segment::gobj | ( |  | ) | `[inline]`

Provides access to the underlying C instance.

GstSegment* Gst::Segment::gobj_copy | ( |  | ) | const

Provides access to the underlying C instance. The caller is responsible for freeing it. Use when directly setting fields in structs.

void Gst::Segment::init | ( | Format | format | ) |

The start/last_stop positions are set to 0 and the stop/duration fields are set to -1 (unknown).

The default rate of 1.0 and no flags are set.

Initialize segment to its default values.

Parameters:

  format | The format of the segment.

Segment& Gst::Segment::operator= | ( | const Segment& | other | ) |

void Gst::Segment::set_duration | ( | Format | format,
|  | gint64 | duration
| ) |  |

Set the duration of the segment to duration.

This function is mainly used by elements that perform seeking and know the total duration of the segment.

This field should be set to allow seeking requests relative to the duration.

Parameters:

  format | The format of the segment.
  duration | The duration of the segment info or -1 if unknown.

void Gst::Segment::set_last_stop | ( | Format | format,
|  | gint64 | position
| ) |  |

Set the last observed stop position in the segment to position.

This field should be set to allow seeking requests relative to the current playing position.

Parameters:

  format | The format of the segment.
  position | The position.

void Gst::Segment::set_newsegment | ( | bool | update,
|  | double | rate,
|  | double | applied_rate,
|  | Format | format,
|  | gint64 | start,
|  | gint64 | stop,
|  | gint64 | time
| ) |  |

Update the segment structure with the field values of a new segment event.

Parameters:

  update | Flag indicating a new segment is started or updated.
  rate | The rate of the segment.
  applied_rate | The applied rate of the segment.
  format | The format of the segment.
  start | The new start value.
  stop | The new stop value.
  time | The new stream time.

void Gst::Segment::set_newsegment | ( | bool | update,
|  | double | rate,
|  | Format | format,
|  | gint64 | start,
|  | gint64 | stop,
|  | gint64 | time
| ) |  |

Update the segment structure with the field values of a new segment event and with a default applied_rate of 1.0.

Parameters:

  update | Flag indicating a new segment is started or updated.
  rate | The rate of the segment.
  format | The format of the segment.
  start | The new start value.
  stop | The new stop value.
  time | The new stream time.

bool Gst::Segment::set_running_time | ( | Format | format,
|  | gint64 | running_time
| ) |  |

Adjust the start/stop and accum values of segment such that the next valid buffer will be one with running_time.

Parameters:

  format | The format of the segment.
  running_time | The running_time in the segment.

Returns:
  `true` if the segment could be updated successfully. If `false` is returned, running_time is -1 or not in segment.

void Gst::Segment::set_seek | ( | double | rate,
|  | Format | format,
|  | SeekFlags | flags,
|  | SeekType | start_type,
|  | gint64 | start,
|  | SeekType | stop_type,
|  | gint64 | stop,
|  | bool & | update
| ) |  |

Update the segment structure with the field values of a seek event (see Gst::Event::new_seek()).

After calling this method, the segment field last_stop and time will contain the requested new position in the segment. The new requested position in the segment depends on rate and start_type and stop_type.

For positive rate, the new position in the segment is the new segment start field when it was updated with a start_type different from Gst::SEEK_TYPE_NONE. If no update was performed on segment start position (Gst::SEEK_TYPE_NONE), start is ignored and segment last_stop is unmodified.

For negative rate, the new position in the segment is the new segment stop field when it was updated with a stop_type different from Gst::SEEK_TYPE_NONE. If no stop was previously configured in the segment, the duration of the segment will be used to update the stop position. If no update was performed on segment stop position (Gst::SEEK_TYPE_NONE), stop is ignored and segment last_stop is unmodified.

The applied rate of the segment will be set to 1.0 by default. If the caller can apply a rate change, it should update segment rate and applied_rate after calling this function.

update will be set to `true` if a seek should be performed to the segment last_stop field. This field can be `false` if, for example, only the rate has been changed but not the playback position.

Parameters:

  rate | The rate of the segment.
  format | The format of the segment.
  flags | The seek flags for the segment.
  start_type | The seek method.
  start | The seek start value.
  stop_type | The seek method.
  stop | The seek stop value.
  update | Boolean holding whether last_stop was updated.

void Gst::Segment::swap | ( | Segment& | other | ) |

gint64 Gst::Segment::to_position | ( | Format | format,
|  | gint64 | running_time
| ) |  | const

Convert running_time into a position in the segment so that to_running_time() with that position returns running_time.

Parameters:

  format | The format of the segment.
  running_time | The running_time in the segment.

Returns:
  The position in the segment for running_time. This function returns -1 when running_time is -1 or when it is not inside segment.

gint64 Gst::Segment::to_running_time | ( | Format | format,
|  | gint64 | position
| ) |  | const

Translate position to the total running time using the currently configured and previously accumulated segments.

Position is a value between segment start and stop time.

This function is typically used by elements that need to synchronize to the global clock in a pipeline. The runnning time is a constantly increasing value starting from 0. When init() is called, this value will reset to 0.

This function returns -1 if the position is outside of segment start and stop.

Parameters:

  format | The format of the segment.
  position | The position in the segment.

Returns:
  The position as the total running time or -1 when an invalid position was given.

gint64 Gst::Segment::to_stream_time | ( | Format | format,
|  | gint64 | position
| ) |  | const

Translate position to stream time using the currently configured segment.

The position value must be between segment start and stop value.

This function is typically used by elements that need to operate on the stream time of the buffers it receives, such as effect plugins. In those use cases, position is typically the buffer timestamp or clock time that one wants to convert to the stream time. The stream time is always between 0 and the total duration of the media stream.

Parameters:

  format | The format of the segment.
  position | The position in the segment.

Returns:
  The position in stream_time or -1 when an invalid position was given.

## Friends And Related Function Documentation

void swap | ( | Segment& | lhs,
|  | Segment& | rhs
| ) |  | `[related]`

Parameters:

  lhs | The left-hand side
  rhs | The right-hand side

Gst::Segment wrap | ( | GstSegment * | object,
|  | bool | take_copy = `false`
| ) |  | `[related]`

A Glib::wrap() method for this object.

Parameters:

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns:
  A C++ instance that wraps this C instance.

## Member Data Documentation

GstSegment* Gst::Segment::gobject_`[protected]`

The documentation for this class was generated from the following file:

- gstreamermm/segment.h